//
//  Babylon Chat
//  Copyright (C) 1997-2002 J. Andrew McLaughlin
// 
//  This program is free software; you can redistribute it and/or modify it
//  under the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
// 
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
//  for more details.
//  
//  You should have received a copy of the GNU General Public License along
//  with this program; if not, write to the Free Software Foundation, Inc.,
//  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//  babylonUser.java
//
import java.util.*;

public class babylonUser {
   // This object keeps all the relevant information about a user for either
   // the server or the client
   protected int id;
   protected String name;
   protected String password;
   protected String additional;
   protected String language;
   protected String chatroomName; // Used by the client
   protected babylonChatRoom chatroom; // Used by the server

   babylonUser(babylonServer server) {
      // This constructor will be used by the server, since it automatically
      // assigns a new user Id
      id = server.getUserId();
      name = "newuser" + id;
      password = "";
      additional = "";
      language = "en"; // English by default
      chatroomName = "";
      chatroom = null;
   }

   babylonUser(int i, String nm, String pw, String add, String lang) {
      // This constructor will be used by the client, with information
      // supplied by the server
      id = i;
      name = nm;
      password = pw;
      additional = add;
      language = lang;
      chatroomName = "";
      chatroom = null;
   }
}
